CC=gcc
FC=gfortran
MKLROOT=/opt/intel/mkl

CCFLAG=-O3 -mtune=native -march=native -fopenmp -Wall -std=c99
FCFLAG=-O3 -mtune=native -march=native -fopenmp -Wall

LIB=-L../../lapack-3.9.1 -llapack -lrefblas -lm 

all: clean RESGKL.o CGS2.o SGEBRDG_4_BISIDE.o ERR.o sbdsqru.o soqds.o slartg6.o slartg7.o slas2u.o srot2.o sfma0.o RESGKL_MAIN.o fileinput_gkl oneone

%.o: lib/%.f
	${FC} ${FCFLAG} -c -o lib/$@ $<

%.o: lib/%.f90
	${FC} ${FCFLAG} -c -o lib/$@ $<

%.o: src/%.f90
	${FC} ${FCFLAG} -c -o src/$@ $<

sfma0.o:
	${CC} ${CCFLAG} -c -o lib/sfma0.o lib/sfma0.c

fileinput_gkl:
	${FC} ${FCFLAG} -o fileinput_gkl fileinput_gkl.f src/CGS2.o src/SGEBRDG_4_BISIDE.o src/RESGKL.o src/ERR.o lib/sbdsqru.o lib/soqds.o lib/slartg6.o lib/slartg7.o lib/slas2u.o lib/srot2.o lib/sfma0.o src/RESGKL_MAIN.o ${LIB}

oneone:
	${CC} ${CCFLAG} -o oneone oneone.c

clean:
	rm -rf *.mod src/*.o lib/*.o fileinput_gkl oneone
