      program fileinput_gkl
      use my_data
      use omp_lib
      IMPLICIT NONE

      integer each,j,accuracy,ls,seedsize
      integer w,y,i,k,l
      integer matrixseed, initseed, method
      integer maxthreads,k0,k1,t
      complex alpha
      double precision n0,l0,l1
      REAL tmp1,tmp2
      character*1000 ARG1,ARG2,ARG3,ARG4,ARG5,ARG6,ARG7,ARG8,ARG9
      integer, allocatable:: seed(:)
      LOGICAL            LSAME
      EXTERNAL           LSAME
      
      CALL GETARG(1,ARG1)
      CALL GETARG(2,ARG2)
      CALL GETARG(3,ARG3)
      CALL GETARG(4,ARG4)
      CALL GETARG(5,ARG5)
      CALL GETARG(6,ARG6)
      CALL GETARG(7,ARG7)
      CALL GETARG(8,ARG8)
      CALL GETARG(9,ARG9)

      read (ARG1,*) method
      read (ARG2,*) nsv
      read (ARG3,*) ncv
      read (ARG6,*) accuracy
      read (ARG8,*) initseed

      if (lsame(ARG4,'s')) THEN
         mode = 0
         write (*,*) 'runnning: sparse mode'
      else if(lsame(ARG4,'d')) THEN
         mode = 1
         write (*,*) 'runnning: dense mode'
      else
         write (*,*) 'error: select d[dense] or s[sparse]'
      endif

      if (lsame(ARG5,'l')) THEN
         ls = 0
         write (*,*) 'runnning: largest singularvalues ...'
      else if(lsame(ARG5,'s')) THEN
         ls = 1
         write (*,*) 'runnning: smallest singularvalues ...'
      else
         write (*,*) 'error: select l or s'
      endif

      open(18,file=ARG9,status='old')
      
      READ (18,*) m
      READ (18,*) n
      READ (18,*) w

      WRITE (*,*) m, n, w
      
      lwork=5*ncv
      if (m>lwork) lwork=m
      if (n>lwork) lwork=n
      if (3*ncv*ncv>lwork) lwork=3*ncv*ncv

      ALLOCATE (work(lwork))
      ALLOCATE (BK(ncv,ncv),VK(n,ncv),UK(m,ncv),VPLUS(n),
     $     VM(n,nsv),UM(m,nsv))
      
      if (.FALSE.) then 

         read (ARG7,*) matrixseed
         call random_seed(size=seedsize) 
         allocate(seed(seedsize))
         DO i=1,seedsize
            seed(i)=matrixseed
         end do
         call random_seed(put=seed)
         
         if(mode==0) then

            ALLOCATE( IAP( m+1 ), JA( w ), A( w ) )

            each = w / m
            write (*,*) 'each row has',each

            DO k=1,m+1
               IAP(k)=1+(k-1)*each
            ENDDO

            DO k=1,w
               call random_number(tmp1)
               JA(k)=int(tmp1*n)+1
            ENDDO

            DO k=1,w
               call random_number(tmp1)
               call random_number(tmp2)
               A(k)=cmplx(tmp1,tmp2)
            ENDDO

         else

            ALLOCATE( DA( n, m ) )

            DO k=1,m
               DO l=1,n
                  call random_number(tmp1)
                  call random_number(tmp2)
                  DA(l,k)=cmplx(tmp1,tmp2)
               ENDDO
            ENDDO
            
         endif

      else

         if(mode==0) then
            
            ALLOCATE( IAP( m+1 ), JA( w ), A( w ) )

            k = 1
            y = 1
            IAP(k) = y
            
 998        READ (18,*, end=999) i,j,alpha
            
            IF (i+1 .NE. k) THEN
               if (k+1 .lt. i+1) write (*,*) 'not row full rank'
               DO k=k+1,i+1
                  IAP(k)=y
               enddo
               k = i+1
            ENDIF
            
            JA(y)=j+1
            A(y)=alpha
            y=y+1
            go to 998
            
 999        if (k+1 .lt. m+1) write (*,*) 'not row full rank'
            DO k=k+1,m+1
               IAP(k)=y
            enddo
            
         else

            ALLOCATE( DA( n, m ) )

 1000       READ (18,*, end=1001) i,j,alpha

            DA(j+1,i+1)=alpha

            go to 1000

 1001       continue
            
         endif

      endif

      close(18)
            
      if(mode==0) then

         maxthreads=omp_get_max_threads()

         ALLOCATE (start_row(maxthreads+1))

         n0 = DBLE(w)/maxthreads

         t=0
         i=0
         
         do while (i<maxthreads .and. t<m) 
            
            start_row(i+1)=t+1
            
            k1=0
            do while(k1<n0 .and. t<m)
               k0=k1
               k1=k0+(IAP(t+2)-IAP(t+1))
               t=t+1
            end do
            
            if(start_row(i+1) .eq. t) cycle
            
            l0=n0-k0
            
            l1=ABS(k1-n0)
            
            if (l0<l1) t=t-1
            
            i=i+1
            
         end do
         start_row(i+1)=m+1
         
         if(i .ne. maxthreads) then
            i=i+1
            do while(i<maxthreads+1)
               start_row(i+1)=1
               i=i+1
            enddo
         endif
         
         do i=1,maxthreads+1
            write (*,*) i,start_row(i)
         end do
         
      endif
      
      CALL resgkl_main(initseed,method,ls,accuracy)

      end


