SUBROUTINE RESGKL_MAIN(ini,method,LS,ACCURACY)
  use my_data
  use omp_lib
  IMPLICIT NONE
  
  integer LS
  COMPLEX IDEN(nsv,nsv),OERR
  REAL MIN_ERR,TMP_ERR,TAVE,CONST,ERR,TMAX
  DOUBLE PRECISION MINT,STARTT,TMPT
  REAL SZERO,SONE,STWO,STEN
  PARAMETER (SZERO = 0.0E+0,SONE = 1.0E+0,STWO = 2.0E+0,STEN = 10.0E+0)
  COMPLEX CZERO,CONE,CTWO,CTEN
  PARAMETER (CZERO = (0.0E+0,0.0E+0),CONE = (1.0E+0,0.0E+0), &
       CTWO = (2.0E+0,0.0E+0),CTEN = (10.0E+0,0.0E+0))
  INTEGER ISEED(4),ini,method
  INTEGER COU,ACCURACY,I,ITR
  COMPLEX CDOTC
  REAL SCNRM2
  EXTERNAL CDOTC,SCNRM2
  
  ISEED( 1 ) = ini
  ISEED( 2 ) = 402+ini*13
  ISEED( 3 ) = 2+ini*3
  ISEED( 4 ) = 111+ini*7
  print *, "MODE = ",MODE
  WRITE (*,*) "M N K L"
  WRITE (*,*) M,N,ncv,nsv
  
  CONST = STEN**(SZERO - accuracy)
  if(min(M,N)<ncv) then
     print *,"! ERR K must be smaller than",min(M,N)
  end if
  
  s0 = SZERO
  opcount = 0
  CALL CLARNV(1,ISEED,N,VPLUS)
  VPLUS = VPLUS / SCNRM2(N,VPLUS,1)
  
  STARTT = omp_get_wtime()
  WRITE(*,*) 
  BK = SZERO
  UK = CZERO
  VK = CZERO
  MIN_ERR = -SONE
  COU = 0
  ITR = 0
  I = 0
  DO WHILE (COU < 1500000)
     
     CALL RESGKL(I,LS,METHOD)
     
     TMP_ERR = MAXVAL(ABS(BK(1:nsv,nsv+1)))
     
     ITR = ITR+1
     TMPT = omp_get_wtime()
     IF ( (TMP_ERR < MIN_ERR) .OR. (MIN_ERR .EQ. -SONE) ) THEN
        MIN_ERR = TMP_ERR
        MINT = TMPT
        COU = -1
     END IF
     
     WRITE(*,*) METHOD,ITR,(TMPT-STARTT),TMP_ERR
     IF(TMP_ERR .LE. CONST) exit
     COU = COU + 1
  END DO
  
  TAVE = ERR(TMAX)
  
  IDEN = CZERO
  DO I = 1,nsv
     IDEN(I,I) = -CONE
  END DO
  CALL CHERK('U','C',nsv,N,SONE,VK,N,SONE,IDEN,nsv)
  OERR = SZERO
!$OMP PARALLEL DO REDUCTION( +:OERR )
  DO I = 2, nsv
     OERR = OERR + CDOTC(I-1,IDEN(1,I),1,IDEN(1,I),1)
  ENDDO
!$OMP END PARALLEL DO
  OERR = STWO*OERR
  DO I = 1, nsv
     OERR = OERR + conjg(IDEN(I,I))*IDEN(I,I)
  ENDDO
  WRITE(*,*) "OERR VK",SQRT(ABS(OERR))

  IDEN = CZERO
  DO I = 1, nsv
     IDEN(I,I) = -CONE
  END DO
  CALL CHERK('U','C',nsv,M,SONE,UK,M,SONE,IDEN,nsv)
  OERR = SZERO
!$OMP PARALLEL DO REDUCTION( +:OERR )
  DO I = 2, nsv
     OERR = OERR + CDOTC(I-1,IDEN(1,I),1,IDEN(1,I),1)
  ENDDO
!$OMP END PARALLEL DO
  OERR = STWO*OERR
  DO I = 1, nsv
     OERR = OERR +conjg(IDEN(I,I))*IDEN(I,I)
  ENDDO
  WRITE(*,*) "OERR UK",SQRT(ABS(OERR))

  WRITE(*,*) "TIME", METHOD,ITR,(TMPT-STARTT),TMP_ERR,"AVE",TAVE,"MAX",TMAX
  WRITE(*,*) "MATRIX VECTOR COMPUTATION (sec)",s0
  WRITE(*,*) "Total number of OP*x operations  :",opcount
  
  DO I = 1,nsv
     WRITE (*,*) "SingularValue",I, BK(I,I)
  END DO

END SUBROUTINE RESGKL_MAIN
